Index: branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 367)
+++ branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 440)
@@ -5695,103 +6255,73 @@
 
 #if DEBUG_MEMC_CC_SEND
-        if(m_debug_cc_send_fsm)
-        {
-          std::cout
-            << "  <MEMC " << name()
-            << ".CC_SEND_CLEANUP_ACK> Cleanup Acknowledgement for srcid "
-            << r_cleanup_to_cc_send_srcid.read()
-            << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CC_SEND_CLEANUP_ACK> Cleanup Ack for srcid "
+          << std::hex << r_cleanup_to_cc_send_srcid.read() << std::endl;
 #endif
         break;
       }
-
-    case CC_SEND_XRAM_RSP_INVAL_HEADER:
-      {
-        // send first flit multi-inval (from XRAM_RSP FSM)
+      ///////////////////////////////////
+      case CC_SEND_XRAM_RSP_INVAL_HEADER:   // send first flit multi-inval (from XRAM_RSP FSM)
+      {
         if(m_xram_rsp_to_cc_send_inst_fifo.rok())
         {
           if(not p_dspin_out.read) break;
-
           r_cc_send_fsm = CC_SEND_XRAM_RSP_INVAL_NLINE;
           break;
         }
-
-        if(r_xram_rsp_to_cc_send_multi_req.read())
-        {
-          r_xram_rsp_to_cc_send_multi_req = false;
-        }
-
+        if(r_xram_rsp_to_cc_send_multi_req.read()) r_xram_rsp_to_cc_send_multi_req = false;
         r_cc_send_fsm = CC_SEND_XRAM_RSP_IDLE;
         break;
       }
-
-    case CC_SEND_XRAM_RSP_INVAL_NLINE:
-      {
-        // send second flit multi-inval (from XRAM_RSP FSM)
+      //////////////////////////////////
+      case CC_SEND_XRAM_RSP_INVAL_NLINE:   // send second flit multi-inval (from XRAM_RSP FSM)
+      {
         if(not p_dspin_out.read) break;
-
         m_cpt_inval_mult++;
-
         xram_rsp_to_cc_send_fifo_get = true;
-        r_cc_send_fsm                = CC_SEND_XRAM_RSP_INVAL_HEADER;
+        r_cc_send_fsm = CC_SEND_XRAM_RSP_INVAL_HEADER;
 
 #if DEBUG_MEMC_CC_SEND
-        if(m_debug_cc_send_fsm)
-        {
-          std::cout
-            << "  <MEMC " << name()
-            << ".CC_SEND_XRAM_RSP_INVAL_NLINE> Broadcast-Inval for line "
-            << r_xram_rsp_to_cc_send_nline.read()
-            << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CC_SEND_XRAM_RSP_INVAL_NLINE> BC-Inval for line "
+          << std::hex << r_xram_rsp_to_cc_send_nline.read() << std::endl;
 #endif
         break;
       }
-
-    case CC_SEND_XRAM_RSP_BRDCAST_HEADER:
-      {
-        // send first flit broadcast-inval (from XRAM_RSP FSM)
+      /////////////////////////////////////
+      case CC_SEND_XRAM_RSP_BRDCAST_HEADER:  // send first flit broadcast-inval (from XRAM_RSP FSM)
+      {
         if(not p_dspin_out.read) break;
-
         r_cc_send_fsm = CC_SEND_XRAM_RSP_BRDCAST_NLINE;
         break;
       }
-
-    case CC_SEND_XRAM_RSP_BRDCAST_NLINE:
-      {
-        // send second flit broadcast-inval (from XRAM_RSP FSM)
+      ////////////////////////////////////
+      case CC_SEND_XRAM_RSP_BRDCAST_NLINE:   // send second flit broadcast-inval (from XRAM_RSP FSM)
+      {
         if(not p_dspin_out.read) break;
-
         m_cpt_inval_brdcast++;
-
         r_xram_rsp_to_cc_send_brdcast_req = false;
         r_cc_send_fsm = CC_SEND_XRAM_RSP_IDLE;
 
 #if DEBUG_MEMC_CC_SEND
-        if(m_debug_cc_send_fsm)
-        {
-          std::cout
-            << "  <MEMC " << name()
-            << ".CC_SEND_XRAM_RSP_BRDCAST_NLINE> Broadcast-Inval for line "
-            << r_xram_rsp_to_cc_send_nline.read()
-            << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CC_SEND_XRAM_RSP_BRDCAST_NLINE> BC-Inval for line "
+          << std::hex << r_xram_rsp_to_cc_send_nline.read() << std::endl;
 #endif
         break;
       }
-
-    case CC_SEND_WRITE_BRDCAST_HEADER:
-      {
-        // send first flit broadcast-inval (from WRITE FSM)
+      //////////////////////////////////
+      case CC_SEND_WRITE_BRDCAST_HEADER:   // send first flit broadcast-inval (from WRITE FSM)
+      {
         if(not p_dspin_out.read) break;
-
         r_cc_send_fsm = CC_SEND_WRITE_BRDCAST_NLINE;
         break;
       }
-
-    case CC_SEND_WRITE_BRDCAST_NLINE:
-      {
-        // send second flit broadcast-inval (from WRITE FSM)
+      /////////////////////////////////
+      case CC_SEND_WRITE_BRDCAST_NLINE:   // send second flit broadcast-inval (from WRITE FSM)
+      {
         if(not p_dspin_out.read) break;
 
@@ -5802,19 +6332,14 @@
 
 #if DEBUG_MEMC_CC_SEND
-        if(m_debug_cc_send_fsm)
-        {
-          std::cout
-            << "  <MEMC " << name()
-            << ".CC_SEND_WRITE_BRDCAST_NLINE> Broadcast-Inval for line "
-            << r_write_to_cc_send_nline.read()
-            << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CC_SEND_WRITE_BRDCAST_NLINE> BC-Inval for line "
+          << std::hex << r_write_to_cc_send_nline.read() << std::endl;
 #endif
         break;
       }
-
-    case CC_SEND_WRITE_UPDT_HEADER:
-      {
-        // send first flit for a multi-update (from WRITE FSM)
+      ///////////////////////////////
+      case CC_SEND_WRITE_UPDT_HEADER:   // send first flit for a multi-update (from WRITE FSM)
+      {
         if(m_write_to_cc_send_inst_fifo.rok())
         {
@@ -5833,10 +6358,8 @@
         break;
       }
-
-    case CC_SEND_WRITE_UPDT_NLINE:
-      {
-        // send second flit for a multi-update (from WRITE FSM)
+      //////////////////////////////
+      case CC_SEND_WRITE_UPDT_NLINE:   // send second flit for a multi-update (from WRITE FSM)
+      {
         if(not p_dspin_out.read) break;
-
         m_cpt_update_mult++;
 
@@ -5845,21 +6368,15 @@
 
 #if DEBUG_MEMC_CC_SEND
-        if(m_debug_cc_send_fsm)
-        {
-          std::cout
-            << "  <MEMC " << name()
-            << ".CC_SEND_WRITE_UPDT_NLINE> Multicast-Update for line "
-            << r_write_to_cc_send_nline.read()
-            << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CC_SEND_WRITE_UPDT_NLINE> Multicast-Update for line "
+          << r_write_to_cc_send_nline.read() << std::endl;
 #endif
         break;
       }
-
-    case CC_SEND_WRITE_UPDT_DATA:
-      {
-        // send N data flits for a multi-update (from WRITE FSM)
+      /////////////////////////////
+      case CC_SEND_WRITE_UPDT_DATA:   // send N data flits for a multi-update (from WRITE FSM)
+      {
         if(not p_dspin_out.read) break;
-
         if(r_cc_send_cpt.read() == (r_write_to_cc_send_count.read()-1))
         {
@@ -5872,19 +6389,15 @@
         break;
       }
-
-    case CC_SEND_CAS_BRDCAST_HEADER:
-      {
-        // send first flit for a broadcast-inval (from CAS FSM)
+      ////////////////////////////////
+      case CC_SEND_CAS_BRDCAST_HEADER:   // send first flit  broadcast-inval (from CAS FSM)
+      {
         if(not p_dspin_out.read) break;
-
         r_cc_send_fsm = CC_SEND_CAS_BRDCAST_NLINE;
         break;
       }
-
-    case CC_SEND_CAS_BRDCAST_NLINE:
-      {
-        // send second flit broadcast-inval (from CAS FSM)
+      ///////////////////////////////
+      case CC_SEND_CAS_BRDCAST_NLINE:   // send second flit broadcast-inval (from CAS FSM)
+      {
         if(not p_dspin_out.read) break;
-
         m_cpt_inval_brdcast++;
 
@@ -5893,19 +6406,14 @@
 
 #if DEBUG_MEMC_CC_SEND
-        if(m_debug_cc_send_fsm)
-        {
-          std::cout
-            << "  <MEMC " << name()
-            << ".CC_SEND_CAS_BRDCAST_NLINE> Broadcast-Inval for line "
-            << r_cas_to_cc_send_nline.read()
-            << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CC_SEND_CAS_BRDCAST_NLINE> Broadcast-Inval for line "
+          << r_cas_to_cc_send_nline.read() << std::endl;
 #endif
         break;
       }
-
-    case CC_SEND_CAS_UPDT_HEADER:
-      {
-        // send first flit for a multi-update (from CAS FSM)
+      /////////////////////////////
+      case CC_SEND_CAS_UPDT_HEADER:   // send first flit for a multi-update (from CAS FSM)
+      {
         if(m_cas_to_cc_send_inst_fifo.rok())
         {
@@ -5925,8 +6433,7 @@
         break;
       }
-
-    case CC_SEND_CAS_UPDT_NLINE:
-      {
-        // send second flit for a multi-update (from CAS FSM)
+      ////////////////////////////
+      case CC_SEND_CAS_UPDT_NLINE:   // send second flit for a multi-update (from CAS FSM)
+      {
         if(not p_dspin_out.read) break;
 
@@ -5937,19 +6444,14 @@
 
 #if DEBUG_MEMC_CC_SEND
-        if(m_debug_cc_send_fsm)
-        {
-          std::cout
-            << "  <MEMC " << name()
-            << ".CC_SEND_CAS_UPDT_NLINE> Multicast-Update for line "
-            << r_cas_to_cc_send_nline.read()
-            << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CC_SEND_CAS_UPDT_NLINE> Multicast-Update for line "
+          << r_cas_to_cc_send_nline.read() << std::endl;
 #endif
         break;
       }
-
-    case CC_SEND_CAS_UPDT_DATA:
-      {
-        // send first data for a multi-update (from CAS FSM)
+      ///////////////////////////
+      case CC_SEND_CAS_UPDT_DATA:   // send first data for a multi-update (from CAS FSM)
+      {
         if(not p_dspin_out.read) break;
 
@@ -5964,10 +6466,8 @@
         break;
       }
-
-    case CC_SEND_CAS_UPDT_DATA_HIGH:
-      {
-        // send second data for a multi-update (from CAS FSM)
+      ////////////////////////////////
+      case CC_SEND_CAS_UPDT_DATA_HIGH:   // send second data for a multi-update (from CAS FSM)
+      {
         if(not p_dspin_out.read) break;
-
         cas_to_cc_send_fifo_get = true;
         r_cc_send_fsm = CC_SEND_CAS_UPDT_HEADER;
@@ -5982,8 +6482,9 @@
   // The CC_RECEIVE fsm controls the DSPIN target port on the coherence
   // network.
-  ///////////////////////////////////////////////////////////////////////////////
+  //////////////////////////////////////////////////////////////////////////////
 
   switch(r_cc_receive_fsm.read())
   {
+    /////////////////////
     case CC_RECEIVE_IDLE:
       {
@@ -5995,11 +6496,11 @@
               DspinDhccpParam::FROM_L1_TYPE);
 
-        if((type == DspinDhccpParam::TYPE_CLEANUP_DATA) ||
-           (type == DspinDhccpParam::TYPE_CLEANUP_INST) )
-        { 
+        if((type == DspinDhccpParam::TYPE_CLEANUP_DATA) or
+           (type == DspinDhccpParam::TYPE_CLEANUP_INST))
+        {
           r_cc_receive_fsm = CC_RECEIVE_CLEANUP;
           break;
         }
-        
+
         if(type == DspinDhccpParam::TYPE_MULTI_ACK)
         {
@@ -6008,63 +6509,70 @@
         }
 
-        assert(
-            false && 
-            "VCI_MEM_CACHE ERROR: Incorrect type in coherence request from "
-            "L1 Cache");
-        
+        assert(false and
+            "VCI_MEM_CACHE ERROR in CC_RECEIVE : "
+            "Illegal type in coherence request");
+
         break;
       }
+    ////////////////////////
     case CC_RECEIVE_CLEANUP:
       {
-        // wait for a valid cleanup flit
-        // wait for a WOK in the CC_RECEIVE to CLEANUP fifo
-        if(not p_dspin_in.write or not m_cc_receive_to_cleanup_fifo.wok()) break;
-
-        bool eop = (
-            DspinDhccpParam::dspin_get(
-              p_dspin_in.data.read(),
-              DspinDhccpParam::FROM_L1_EOP)
-            == 0x1);
+        // write first CLEANUP flit in CC_RECEIVE to CLEANUP fifo
+
+        if(not p_dspin_in.write or not m_cc_receive_to_cleanup_fifo.wok())
+          break;
+
+        assert(not p_dspin_in.eop.read() and
+            "VCI_MEM_CACHE ERROR in CC_RECEIVE : "
+            "CLEANUP command must have two flits");
 
         cc_receive_to_cleanup_fifo_put = true;
-        if(eop)
-        {
-          r_cc_receive_fsm = CC_RECEIVE_IDLE;
-        }
+        r_cc_receive_fsm               = CC_RECEIVE_CLEANUP_EOP;
 
         break;
       }
+    ////////////////////////////
+    case CC_RECEIVE_CLEANUP_EOP:
+      {
+        // write second CLEANUP flit in CC_RECEIVE to CLEANUP fifo
+
+        if(not p_dspin_in.write or not m_cc_receive_to_cleanup_fifo.wok())
+          break;
+
+        assert(p_dspin_in.eop.read() and
+            "VCI_MEM_CACHE ERROR in CC_RECEIVE : "
+            "CLEANUP command must have two flits");
+
+        cc_receive_to_cleanup_fifo_put = true;
+        r_cc_receive_fsm               = CC_RECEIVE_IDLE;
+
+        break;
+      }
+
+    //////////////////////////
     case CC_RECEIVE_MULTI_ACK:
       {
-        // wait for a valid multicast acknowledgement flit
+        // write MULTI_ACK flit in CC_RECEIVE to MULTI_ACK fifo
+
         // wait for a WOK in the CC_RECEIVE to MULTI_ACK fifo
-        if(not p_dspin_in.write or not m_cc_receive_to_multi_ack_fifo.wok()) break;
-
-        bool eop = (
-            DspinDhccpParam::dspin_get(
-              p_dspin_in.data.read(),
-              DspinDhccpParam::FROM_L1_EOP) 
-            == 0x1);
-
-        cc_receive_to_multi_ack_fifo_put  = true;
-        if(eop)
-        {
-          r_cc_receive_fsm = CC_RECEIVE_IDLE;
-        }
-
+        if(not p_dspin_in.write or not m_cc_receive_to_multi_ack_fifo.wok())
+          break;
+
+        assert(p_dspin_in.eop.read() and
+            "VCI_MEM_CACHE ERROR in CC_RECEIVE : "
+            "MULTI_ACK command must have one flit");
+
+        cc_receive_to_multi_ack_fifo_put = true;
+        r_cc_receive_fsm                 = CC_RECEIVE_IDLE;
         break;
       }
-    default:
-      {
-        assert(
-            false &&
-            "VCI_MEM_CACHE ERROR: Invalid state in CC_RECEIVE FSM");
-      }
   }
-  /////////////////////////////////////////////////////////////////////
+  //////////////////////////////////////////////////////////////////////////
   //    TGT_RSP FSM
-  /////////////////////////////////////////////////////////////////////
+  //////////////////////////////////////////////////////////////////////////
   // The TGT_RSP fsm sends the responses on the VCI target port
-  // with a round robin priority between six requests :
+  // with a round robin priority between eigth requests :
+  // - r_config_to_tgt_rsp_req
+  // - r_tgt_cmd_to_tgt_rsp_req
   // - r_read_to_tgt_rsp_req
   // - r_write_to_tgt_rsp_req
@@ -6073,14 +6581,22 @@
   // - r_xram_rsp_to_tgt_rsp_req
   // - r_multi_ack_to_tgt_rsp_req
-  // The  ordering is :  read > write > cas > xram > init > cleanup
-  /////////////////////////////////////////////////////////////////////
+  //
+  // The ordering is :
+  //   config >tgt_cmd > read > write > cas > xram > multi_ack > cleanup
+  //////////////////////////////////////////////////////////////////////////
 
   switch(r_tgt_rsp_fsm.read())
   {
-    case TGT_RSP_READ_IDLE:
-    { 
-      // write requests have the highest priority
-      if(r_write_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      else if(r_cas_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CAS  ;
+    /////////////////////////
+    case TGT_RSP_CONFIG_IDLE:  // tgt_cmd requests have the highest priority
+    {
+      if(r_tgt_cmd_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
+      else if(r_read_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_READ;
+        r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
+      }
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS;
       else if(r_xram_rsp_to_tgt_rsp_req)
       {
@@ -6088,17 +6604,19 @@
         r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
       }
-      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_INIT   ;
-      else if(r_cleanup_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
-      else if(r_read_to_tgt_rsp_req)
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
+      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      break;
+    }
+    //////////////////////////
+    case TGT_RSP_TGT_CMD_IDLE: // read requests have the highest priority
+    {
+      if(r_read_to_tgt_rsp_req)
       {
         r_tgt_rsp_fsm = TGT_RSP_READ;
         r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
       }
-      break;
-    }
-    ////////////////////////
-    case TGT_RSP_WRITE_IDLE:  // cas requests have the highest priority
-    {
-      if(r_cas_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CAS;
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS;
       else if(r_xram_rsp_to_tgt_rsp_req)
       {
@@ -6106,6 +6624,24 @@
         r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
       }
-      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_INIT   ;
-      else if(r_cleanup_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
+      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
+      break;
+    }
+    ///////////////////////
+    case TGT_RSP_READ_IDLE: // write requests have the highest priority
+    {
+      if(r_write_to_tgt_rsp_req)          r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS;
+      else if(r_xram_rsp_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_XRAM;
+        r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
+      }
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
+      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
       else if(r_read_to_tgt_rsp_req)
       {
@@ -6113,18 +6649,19 @@
         r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
       }
-
-      else if(r_write_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      break;
-    }
-    ///////////////////////
-    case TGT_RSP_CAS_IDLE:   // xram_rsp requests have the highest priority
-    {
-      if(r_xram_rsp_to_tgt_rsp_req)
+      break;
+    }
+    ////////////////////////
+    case TGT_RSP_WRITE_IDLE: // cas requests have the highest priority
+    {
+      if(r_cas_to_tgt_rsp_req)            r_tgt_rsp_fsm = TGT_RSP_CAS;
+      else if(r_xram_rsp_to_tgt_rsp_req)
       {
         r_tgt_rsp_fsm = TGT_RSP_XRAM;
         r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
       }
-      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_INIT   ;
-      else if(r_cleanup_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
+      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
       else if(r_read_to_tgt_rsp_req)
       {
@@ -6132,14 +6669,19 @@
         r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
       }
-      else if(r_write_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      else if(r_cas_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CAS  ;
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
       break;
     }
     ///////////////////////
-    case TGT_RSP_XRAM_IDLE:   // init requests have the highest priority
-    {
-
-      if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_INIT   ;
-      else if(r_cleanup_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+    case TGT_RSP_CAS_IDLE: // xram_rsp requests have the highest priority
+    {
+      if(r_xram_rsp_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_XRAM;
+        r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
+      }
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK   ;
+      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
       else if(r_read_to_tgt_rsp_req)
       {
@@ -6147,6 +6689,23 @@
         r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
       }
-      else if(r_write_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      else if(r_cas_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CAS  ;
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
+      break;
+    }
+    ///////////////////////
+    case TGT_RSP_XRAM_IDLE: // multi ack requests have the highest priority
+    {
+
+      if(r_multi_ack_to_tgt_rsp_req)      r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK   ;
+      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
+      else if(r_read_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_READ;
+        r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
+      }
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
       else if(r_xram_rsp_to_tgt_rsp_req)
       {
@@ -6156,8 +6715,10 @@
       break;
     }
-    ///////////////////////
-    case TGT_RSP_INIT_IDLE:   // cleanup requests have the highest priority
-    {
-      if(r_cleanup_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+    ////////////////////////////
+    case TGT_RSP_MULTI_ACK_IDLE: // cleanup requests have the highest priority
+    {
+      if(r_cleanup_to_tgt_rsp_req)        r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
       else if(r_read_to_tgt_rsp_req)
       {
@@ -6165,6 +6726,6 @@
         r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
       }
-      else if(r_write_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      else if(r_cas_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CAS  ;
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
       else if(r_xram_rsp_to_tgt_rsp_req)
       {
@@ -6172,17 +6733,19 @@
         r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
       }
-      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_INIT;
-      break;
-    }
-    ///////////////////////
-    case TGT_RSP_CLEANUP_IDLE:    // read requests have the highest priority
-    {
-      if(r_read_to_tgt_rsp_req)
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
+      break;
+    }
+    //////////////////////////
+    case TGT_RSP_CLEANUP_IDLE: // tgt cmd requests have the highest priority
+    {
+      if(r_config_to_tgt_rsp_req)         r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
+      else if(r_read_to_tgt_rsp_req)
       {
         r_tgt_rsp_fsm = TGT_RSP_READ;
         r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
       }
-      else if(r_write_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      else if(r_cas_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CAS  ;
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
       else if(r_xram_rsp_to_tgt_rsp_req)
       {
@@ -6190,6 +6753,52 @@
         r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
       }
-      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_INIT   ;
-      else if(r_cleanup_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK   ;
+      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      break;
+    }
+    ////////////////////
+    case TGT_RSP_CONFIG:  // send the response for a config transaction
+    {
+      if ( p_vci_tgt.rspack )
+      {
+        r_config_to_tgt_rsp_req = false;
+        r_tgt_rsp_fsm           = TGT_RSP_CONFIG_IDLE;
+
+#if DEBUG_MEMC_TGT_RSP
+if( m_debug )
+{
+  std::cout
+    << "  <MEMC " << name()
+    << " TGT_RSP_CONFIG>  Config transaction completed response"
+    << " / rsrcid = " << std::hex << r_config_to_tgt_rsp_srcid.read()
+    << " / rtrdid = " << r_config_to_tgt_rsp_trdid.read()
+    << " / rpktid = " << r_config_to_tgt_rsp_pktid.read()
+    << std::endl;
+}
+#endif
+      }
+      break;
+    }
+    /////////////////////
+    case TGT_RSP_TGT_CMD: // send the response for a segmentation violation
+    {
+      if ( p_vci_tgt.rspack )
+      {
+        r_tgt_cmd_to_tgt_rsp_req = false;
+        r_tgt_rsp_fsm            = TGT_RSP_TGT_CMD_IDLE;
+
+#if DEBUG_MEMC_TGT_RSP
+if( m_debug )
+{
+  std::cout
+    << "  <MEMC " << name()
+    << " TGT_RSP_TGT_CMD> Segmentation violation response"
+    << " / rsrcid = " << std::hex << r_tgt_cmd_to_tgt_rsp_srcid.read()
+    << " / rtrdid = " << r_tgt_cmd_to_tgt_rsp_trdid.read()
+    << " / rpktid = " << r_tgt_cmd_to_tgt_rsp_pktid.read()
+    << std::endl;
+}
+#endif
+      }
       break;
     }
@@ -6201,21 +6810,23 @@
 
 #if DEBUG_MEMC_TGT_RSP
-if( m_debug_tgt_rsp_fsm )
+if( m_debug )
 {
   std::cout
-    << "  <MEMC " << name() << ".TGT_RSP_READ> Read response"
-    << " / rsrcid = " << std::dec << r_read_to_tgt_rsp_srcid.read()
+    << "  <MEMC " << name() << " TGT_RSP_READ> Read response"
+    << " / rsrcid = " << std::hex << r_read_to_tgt_rsp_srcid.read()
     << " / rtrdid = " << r_read_to_tgt_rsp_trdid.read()
     << " / rpktid = " << r_read_to_tgt_rsp_pktid.read()
-    << " / rdata = " << std::hex << r_read_to_tgt_rsp_data[r_tgt_rsp_cpt.read()].read()
+    << " / rdata = " << r_read_to_tgt_rsp_data[r_tgt_rsp_cpt.read()].read()
     << " / cpt = " << std::dec << r_tgt_rsp_cpt.read() << std::endl;
 }
 #endif
-  
-        uint32_t last_word_idx = r_read_to_tgt_rsp_word.read() + r_read_to_tgt_rsp_length.read() - 1;
+
+        uint32_t last_word_idx = r_read_to_tgt_rsp_word.read() +
+                                 r_read_to_tgt_rsp_length.read() - 1;
         bool     is_last_word  = (r_tgt_rsp_cpt.read() == last_word_idx);
         bool     is_ll         = ((r_read_to_tgt_rsp_pktid.read() & 0x7) == TYPE_LL);
 
-        if ( (is_last_word and not is_ll) or (r_tgt_rsp_key_sent.read() and is_ll))
+        if ((is_last_word              and not is_ll) or
+            (r_tgt_rsp_key_sent.read() and is_ll))
         {
           // Last word in case of READ or second flit in case if LL
@@ -6245,11 +6856,9 @@
 
 #if DEBUG_MEMC_TGT_RSP
-        if(m_debug_tgt_rsp_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".TGT_RSP_WRITE> Write response"
-                    << " / rsrcid = " << std::dec << r_write_to_tgt_rsp_srcid.read()
-                    << " / rtrdid = " << r_write_to_tgt_rsp_trdid.read()
-                    << " / rpktid = " << r_write_to_tgt_rsp_pktid.read() << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name() << " TGT_RSP_WRITE> Write response"
+          << " / rsrcid = " << std::hex << r_write_to_tgt_rsp_srcid.read()
+          << " / rtrdid = " << r_write_to_tgt_rsp_trdid.read()
+          << " / rpktid = " << r_write_to_tgt_rsp_pktid.read() << std::endl;
 #endif
         r_tgt_rsp_fsm = TGT_RSP_WRITE_IDLE;
@@ -6258,5 +6867,5 @@
       break;
     }
-    ///////////////////
+    /////////////////////
     case TGT_RSP_CLEANUP:   // pas clair pour moi (AG)
     {
@@ -6265,11 +6874,9 @@
 
 #if DEBUG_MEMC_TGT_RSP
-        if(m_debug_tgt_rsp_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".TGT_RSP_CLEANUP> Cleanup response"
-                    << " / rsrcid = " << std::dec << r_cleanup_to_tgt_rsp_srcid.read()
-                    << " / rtrdid = " << r_cleanup_to_tgt_rsp_trdid.read()
-                    << " / rpktid = " << r_cleanup_to_tgt_rsp_pktid.read() << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name() << " TGT_RSP_CLEANUP> Cleanup response"
+          << " / rsrcid = " << std::hex << r_cleanup_to_tgt_rsp_srcid.read()
+          << " / rtrdid = " << r_cleanup_to_tgt_rsp_trdid.read()
+          << " / rpktid = " << r_cleanup_to_tgt_rsp_pktid.read() << std::endl;
 #endif
         r_tgt_rsp_fsm = TGT_RSP_CLEANUP_IDLE;
@@ -6278,5 +6885,5 @@
       break;
     }
-    //////////////////
+    /////////////////
     case TGT_RSP_CAS:    // send one atomic word response
     {
@@ -6285,11 +6892,9 @@
 
 #if DEBUG_MEMC_TGT_RSP
-        if(m_debug_tgt_rsp_fsm)
-        {
-          std::cout << "  <MEMC " << name() << ".TGT_RSP_CAS> CAS response"
-                    << " / rsrcid = " << std::dec << r_cas_to_tgt_rsp_srcid.read()
-                    << " / rtrdid = " << r_cas_to_tgt_rsp_trdid.read()
-                    << " / rpktid = " << r_cas_to_tgt_rsp_pktid.read() << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name() << " TGT_RSP_CAS> CAS response"
+          << " / rsrcid = " << std::hex << r_cas_to_tgt_rsp_srcid.read()
+          << " / rtrdid = " << r_cas_to_tgt_rsp_trdid.read()
+          << " / rpktid = " << r_cas_to_tgt_rsp_pktid.read() << std::endl;
 #endif
         r_tgt_rsp_fsm = TGT_RSP_CAS_IDLE;
@@ -6298,6 +6903,5 @@
       break;
     }
-
-    ///////////////////////
+    //////////////////
     case TGT_RSP_XRAM:    // send the response after XRAM access
     {
@@ -6306,16 +6910,14 @@
 
 #if DEBUG_MEMC_TGT_RSP
-if( m_debug_tgt_rsp_fsm )
-{
-  std::cout 
-    << "  <MEMC " << name() << ".TGT_RSP_XRAM> Response following XRAM access"
-    << " / rsrcid = " << std::dec << r_xram_rsp_to_tgt_rsp_srcid.read()
-    << " / rtrdid = " << r_xram_rsp_to_tgt_rsp_trdid.read()
-    << " / rpktid = " << r_xram_rsp_to_tgt_rsp_pktid.read()
-    << " / rdata = " << std::hex << r_xram_rsp_to_tgt_rsp_data[r_tgt_rsp_cpt.read()].read()
-    << " / cpt = " << std::dec << r_tgt_rsp_cpt.read() << std::endl;
-}
-#endif
-        uint32_t last_word_idx = r_xram_rsp_to_tgt_rsp_word.read() + r_xram_rsp_to_tgt_rsp_length.read() - 1;
+if( m_debug )
+std::cout << "  <MEMC " << name() << " TGT_RSP_XRAM> Response following XRAM access"
+          << " / rsrcid = " << std::hex << r_xram_rsp_to_tgt_rsp_srcid.read()
+          << " / rtrdid = " << r_xram_rsp_to_tgt_rsp_trdid.read()
+          << " / rpktid = " << r_xram_rsp_to_tgt_rsp_pktid.read()
+          << " / rdata = " << r_xram_rsp_to_tgt_rsp_data[r_tgt_rsp_cpt.read()].read()
+          << " / cpt = " << std::dec << r_tgt_rsp_cpt.read() << std::endl;
+#endif
+        uint32_t last_word_idx = r_xram_rsp_to_tgt_rsp_word.read() +
+                                 r_xram_rsp_to_tgt_rsp_length.read() - 1;
         bool     is_last_word  = (r_tgt_rsp_cpt.read() == last_word_idx);
         bool     is_ll         = ((r_xram_rsp_to_tgt_rsp_pktid.read() & 0x7) == TYPE_LL);
@@ -6335,5 +6937,5 @@
           {
             r_tgt_rsp_key_sent = true;                     // Send second flit of ll
-          }                                                                            
+          }
           else
           {
@@ -6344,6 +6946,6 @@
       break;
     }
-    //////////////////
-    case TGT_RSP_INIT:    // send the write response after coherence transaction
+    ///////////////////////
+    case TGT_RSP_MULTI_ACK:    // send the write response after coherence transaction
     {
       if(p_vci_tgt.rspack)
